// C Source File
// Created 2/9/01; 10:52:07 AM

/*
A Sample TSR Event Hook By Greg Dietsche
	LAST REVISION:07/20/2001

Many thanks to:
			Kevin Kofler - h220xTSR.h and suggestions to improve this code
			Samuel Stearley - for getting me started...
			Dave Watson	- Ideas from On Key express
			the TIGCC Programming Message board
			the Assembly-89 mailing list

IT IS NOT A GOOD IDEA TO RUN THIS PROGRAM DIRECTLY ON YOUR CALC!

it is probably best to compile this and the install program from the
command prompt instead of the TIGCC IDE...

Use: tigcc -O3 -outputbin main.c to compile
then convert it to an array using the ttbin2hex program from the tict 
tools suite. Once that is completed, the array should be defined as
unsigned char tsr[]={the array}; and placed in a file called array.h
for the install.c program. For more information, look in the file 
called make.bat.


Revision History:
	**11/10/2001**
	+A small fix to make it compile correctly with TIGCC .92
	
	**07/20/2001**
	+Fixed OPTIMIZE_ROM_CALLS support so it should work perfectly now.
	
	**04/2001**
		+added support for OPTIMIZE_ROM_CALLS
		+changed the entry point from _main to Install_TSR to avoid problems with
			TIGCC .91 with Service Pack 1 installed.
		+a few changes to the way the jump to the EventHandler function is written
*/

//Install_TSR takes the place of _main, the main difference is that by doing
//it this way, it is possible to reliably pass a variable to the function
//this will be changed to jmp EventHandler by Install_TSR; that way, the hook
//will be called and not the install function...
	asm("/* Entry Point for the TSR install function */");
	asm("jmp Install_TSR:l"); 
	

//Use Speed Optimization
	#define OPTIMIZE_ROM_CALLS


//Important Variables...
	static void *gpOldHandler=0; 		//a pointer to a pointer to the old handler
	short _ti89;                	 // Produce .89Z File


//Header Files
	#include <tigcclib.h>          //Include All Header Files	
	#include "Handler.h"					//The EVENT Hook function


// Main Function -  this function will ONLY be executed once!
//Insall_TSR takes the place of _main and takes a pointer the location in the
//tsr that contains the pointer to the previous event hook.
void Install_TSR(void* pOldHandler)
{
/*
it is vitally important that this function does NOT fail!
so if something is amiss, the install program should be the one
to catch the error because catching it here would result in a memory leak

There are two reasons for having this startup function
1. to setup the opcode for jmp EventHandler
2. to store global variables that will be used during the execution of
	 EventHandler. These include the pointer to the next event hook to be
	 called.
*/
	
	//save the pointer to a pointer to the next event hook in line to be called
		gpOldHandler=pOldHandler;
		pOldHandler+=6;	//skipping 4 + 2 bytes (4=size of a pointer) 2= size of
										//jmp opcode

			//0x4EF9 is the op-code for an absolute jump (2 bytes)
			//		*(unsigned int*)pOldHandler=0x4EF9;
			//			pOldHandler+=2;
			//taken care of already because of the code jmp Install_TSR:l!
			
	//write the 4 byte address that points to the Event Hook to finish the 
	//opcode for jmp EventHandler. This changes jmp Install_TSR to
	//jmp EventHandler.
		*(unsigned long*)pOldHandler=(unsigned long)EventHandler;

}
